/*----------------------------------------------------------------------
    Class for Index Set          iset.h
        Written  by H.Goto, Dec. 1997
        Modified by H.Goto, Apr. 1999
----------------------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1997-1999  Hideaki Goto

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hideaki Goto, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/


#ifndef	iset_h
#define	iset_h

class IDXSET {
    private:
	int	bufsize;
    public:
	int	*idlist;
	int	counts,actcounts;
	int	clear();
	int	realloc(int size);
	inline int	alloc(int size){  return( realloc(size) );  }
	int	addmember(int id);	/* id >= 0 */
	int	removemember(int i);
	int	truncate();
	int	merge(IDXSET *idxset);
		IDXSET();
	virtual	~IDXSET();
};

#endif	/* iset_h */
